"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RouteHeaderView = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactNative = require("react-native");

var _RNINavigatorRouteHeaderView = require("../native_components/RNINavigatorRouteHeaderView");

var _LibraryConstants = require("../constants/LibraryConstants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

class RouteHeaderView extends _react.default.PureComponent {
  render() {
    const props = this.props;
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.headerContainer,
      pointerEvents: 'box-none'
    }, /*#__PURE__*/_react.default.createElement(_RNINavigatorRouteHeaderView.RNINavigatorRouteHeaderView, _extends({
      pointerEvents: 'box-none'
    }, props, {
      nativeID: _LibraryConstants.NativeIDKeys.RouteHeader,
      config: props.config,
      headerTopPadding: props.headerTopPadding,
      style: [props.style]
    }), props.children));
  }

}

exports.RouteHeaderView = RouteHeaderView;
;

const styles = _reactNative.StyleSheet.create({
  headerContainer: {
    position: 'absolute',
    top: 0,
    left: 0,
    right: 0,
    height: 0
  }
});
//# sourceMappingURL=RouteHeaderView.js.map