"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CompareImageConfig = exports.CompareUIImageConfig = exports.CompareImageSystemConfig = exports.CompareImageRectConfig = exports.CompareImageGradientConfig = void 0;

var _fastDeepEqual = _interopRequireDefault(require("fast-deep-equal"));

var _CompareUtilities = require("./CompareUtilities");

var _CompareMisc = require("./CompareMisc");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function comparePointOrPointPreset(oldItem, newItem) {
  if (typeof oldItem === 'string') {
    return oldItem === newItem;
  }

  ;
  return _CompareUtilities.CompareUtilities.shallowCompareObject(oldItem, newItem);
}

;

class CompareImageGradientConfig {
  static compare(oldItem, newItem) {
    return _CompareUtilities.CompareUtilities.compareObject(CompareImageGradientConfig.propertyMap, oldItem, newItem);
  }

}

exports.CompareImageGradientConfig = CompareImageGradientConfig;

_defineProperty(CompareImageGradientConfig, "propertyMap", {
  type: {
    mode: 'shallow'
  },
  width: {
    mode: 'shallow'
  },
  height: {
    mode: 'shallow'
  },
  borderRadius: {
    mode: 'shallow'
  },
  colors: {
    mode: 'shallowArray'
  },
  locations: {
    mode: 'shallowArray'
  },
  startPoint: {
    mode: 'custom',
    customCompare: comparePointOrPointPreset
  },
  endPoint: {
    mode: 'custom',
    customCompare: comparePointOrPointPreset
  }
});

;

class CompareImageRectConfig {
  static compare(oldItem, newItem) {
    return _CompareUtilities.CompareUtilities.compareObject(this.propertyMap, oldItem, newItem);
  }

}

exports.CompareImageRectConfig = CompareImageRectConfig;

_defineProperty(CompareImageRectConfig, "propertyMap", {
  width: {
    mode: 'shallow'
  },
  height: {
    mode: 'shallow'
  },
  fillColor: {
    mode: 'shallow'
  },
  borderRadius: {
    mode: 'shallow'
  }
});

;

class CompareImageSystemConfig {
  static compare(oldItem, newItem) {
    return _CompareUtilities.CompareUtilities.compareObject(this.propertyMap, oldItem, newItem);
  }

}

exports.CompareImageSystemConfig = CompareImageSystemConfig;

_defineProperty(CompareImageSystemConfig, "propertyMap", {
  systemName: {
    mode: 'shallow'
  },
  pointSize: {
    mode: 'shallow'
  },
  weight: {
    mode: 'shallow'
  },
  scale: {
    mode: 'shallow'
  },
  hierarchicalColor: {
    mode: 'shallow'
  },
  paletteColors: {
    mode: 'shallowArray'
  }
});

;

class CompareUIImageConfig {
  static compare(oldItem, newItem) {
    return _CompareUtilities.CompareUtilities.compareObject(CompareUIImageConfig.propertyMap, oldItem, newItem, true);
    ;
  }

}

exports.CompareUIImageConfig = CompareUIImageConfig;

_defineProperty(CompareUIImageConfig, "propertyMap", {
  renderingMode: {
    mode: 'shallow'
  },
  tint: {
    mode: 'custom',
    customCompare: _CompareMisc.compareColor
  }
});

;

class CompareImageConfig {
  static compare(oldItem, newItem) {
    if (oldItem.type !== newItem.type) return false;

    switch (oldItem.type) {
      case 'IMAGE_REQUIRE':
        return CompareUIImageConfig.compare(oldItem.imageOptions, newItem.imageOptions) || (0, _fastDeepEqual.default)(oldItem.imageValue, newItem.imageOptions);

      case 'IMAGE_ASSET':
        return CompareUIImageConfig.compare(oldItem.imageOptions, newItem.imageOptions) || oldItem.imageValue === newItem.imageValue;

      case 'IMAGE_SYSTEM':
        return CompareUIImageConfig.compare(oldItem.imageOptions, newItem.imageOptions) || CompareImageSystemConfig.compare(oldItem.imageValue, newItem.imageValue);

      case 'IMAGE_RECT':
        return CompareImageRectConfig.compare(oldItem.imageValue, newItem.imageValue);

      case 'IMAGE_GRADIENT':
        return CompareImageGradientConfig.compare(oldItem.imageValue, newItem.imageValue);

      default:
        return (0, _fastDeepEqual.default)(oldItem, newItem);
    }

    ;
  }

}

exports.CompareImageConfig = CompareImageConfig;
;
//# sourceMappingURL=CompareImageConfig.js.map