"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CompareRouteOptions = exports.CompareRouteTransitionPopConfig = exports.CompareRouteTransitionPushConfig = void 0;

var _CompareUtilities = require("./CompareUtilities");

var _CompareNavBarItemConfig = require("./CompareNavBarItemConfig");

var _CompareNavBarAppearanceCombinedConfig = require("./CompareNavBarAppearanceCombinedConfig");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// Note: These functions are used to compare objects and decide whether or not to
// to trigger an update or re-render, so it has to be fast.
// Of course, we can use `deepCompare` and `JSON.stringify` to compare two objects,
// but using `&&` ("short-circuit" eval.) will return early once a comparison is false,
// which is a lot faster than serializing an entire object into a string and then 
// comparing them (it also doesn't preserve order, meaning that the comparisons for
// deeply nested objects might be wrong sometimes).
// This is a ugly brute force approach, and there might be other ways to do this, but
// it'll do for now.
class CompareRouteTransitionPushConfig {
  static compare(oldItem, newItem) {
    return _CompareUtilities.CompareUtilities.compareObject(CompareRouteTransitionPushConfig.propertyMap, oldItem, newItem);
  }

  static unwrapAndCompare(oldItem, newItem) {
    if (oldItem == null && newItem == null) return true;
    if (oldItem == null || newItem == null) return false;
    return this.compare(oldItem, newItem);
  }

}

exports.CompareRouteTransitionPushConfig = CompareRouteTransitionPushConfig;

_defineProperty(CompareRouteTransitionPushConfig, "propertyMap", {
  // shallow compare
  type: {
    mode: 'shallow'
  },
  duration: {
    mode: 'shallow'
  }
});

;

class CompareRouteTransitionPopConfig {
  static compare(oldItem, newItem) {
    return _CompareUtilities.CompareUtilities.compareObject(CompareRouteTransitionPopConfig.propertyMap, oldItem, newItem);
  }

  static unwrapAndCompare(oldItem, newItem) {
    if (oldItem == null && newItem == null) return true;
    if (oldItem == null || newItem == null) return false;
    return this.compare(oldItem, newItem);
  }

}

exports.CompareRouteTransitionPopConfig = CompareRouteTransitionPopConfig;

_defineProperty(CompareRouteTransitionPopConfig, "propertyMap", {
  // shallow compare
  type: {
    mode: 'shallow'
  },
  duration: {
    mode: 'shallow'
  }
});

;

class CompareRouteOptions {
  static compare(oldItem, newItem) {
    if (oldItem == null && newItem == null) return true;
    if (oldItem == null || newItem == null) return false;
    return _CompareUtilities.CompareUtilities.compareObject(this.propertyMap, oldItem, newItem);
  }

  static unwrapAndCompare(oldItem, newItem) {
    if (oldItem == null && newItem == null) return true;
    if (oldItem == null || newItem == null) return false;
    return this.compare(oldItem, newItem);
  }

}

exports.CompareRouteOptions = CompareRouteOptions;

_defineProperty(CompareRouteOptions, "propertyMap", {
  // shallow compare 
  routeTitle: {
    mode: 'shallow'
  },
  prompt: {
    mode: 'shallow'
  },
  largeTitleDisplayMode: {
    mode: 'shallow'
  },
  hidesBackButton: {
    mode: 'shallow'
  },
  backButtonTitle: {
    mode: 'shallow'
  },
  backButtonDisplayMode: {
    mode: 'shallow'
  },
  leftItemsSupplementBackButton: {
    mode: 'shallow'
  },
  navigationBarVisibility: {
    mode: 'shallow'
  },
  statusBarStyle: {
    mode: 'shallow'
  },
  applyBackButtonConfigToCurrentRoute: {
    mode: 'shallow'
  },
  allowTouchEventsToPassThroughNavigationBar: {
    mode: 'shallow'
  },
  automaticallyAddHorizontalSafeAreaInsets: {
    mode: 'shallow'
  },
  routeContainerStyle: {
    mode: 'shallowObject'
  },
  searchBarConfig: {
    mode: 'shallowObject'
  },
  transitionConfigPush: {
    mode: 'custom',
    customCompare: CompareRouteTransitionPushConfig.compare
  },
  // custom compare
  navBarAppearanceOverride: {
    mode: 'custom',
    customCompare: _CompareNavBarAppearanceCombinedConfig.CompareNavBarAppearanceCombinedConfig.compare
  },
  transitionConfigPop: {
    mode: 'custom',
    customCompare: CompareRouteTransitionPopConfig.compare
  },
  navBarButtonLeftItemsConfig: {
    mode: 'custom',
    customCompare: _CompareNavBarItemConfig.CompareNavBarItemsConfig.compare
  },
  navBarButtonRightItemsConfig: {
    mode: 'custom',
    customCompare: _CompareNavBarItemConfig.CompareNavBarItemsConfig.compare
  },
  navBarButtonBackItemConfig: {
    mode: 'custom',
    customCompare: _CompareNavBarItemConfig.CompareNavBarBackItemConfig.compare
  }
});

;
//# sourceMappingURL=CompareRouteOptions.js.map