"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withRouteViewLifecycle = withRouteViewLifecycle;

var _react = _interopRequireDefault(require("react"));

var _NavigationContext = require("../context/NavigationContext");

var _NavigatorRouteViewEventEmitter = require("../types/NavigatorRouteViewEventEmitter");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// TODO (013): Delete this
function withRouteViewLifecycle(WrappedComponent) {
  var _class, _temp;

  return _temp = _class = class extends _react.default.PureComponent {
    constructor(...args) {
      super(...args);

      _defineProperty(this, "childRef", void 0);

      _defineProperty(this, "_handleChildRef", node => {
        // @ts-ignore
        const {
          ref
        } = this.props; // store a copy of the child comp ref

        this.childRef = node;

        if (typeof ref === 'function') {
          ref(node);
        } else if (ref) {
          ref.current = node;
        }

        ;
      });
    }

    componentDidMount() {
      const {
        navigation
      } = this.context;
      const routeViewEmitter = navigation.getRefToNavRouteEmitter();

      for (const eventKey in _NavigatorRouteViewEventEmitter.NavigatorRouteViewEvents) {
        const functionName = "handle-".concat(eventKey); // @ts-ignore

        this[functionName] = event => {
          var _this$childRef, _this$childRef$onModa;

          // @ts-ignore
          (_this$childRef = this.childRef) === null || _this$childRef === void 0 ? void 0 : (_this$childRef$onModa = _this$childRef.onModalShow) === null || _this$childRef$onModa === void 0 ? void 0 : _this$childRef$onModa.call(_this$childRef, event);
        }; // @ts-ignore


        routeViewEmitter.addListener(eventKey, this[functionName]);
      }

      ;
    }

    componentWillUnmount() {
      const {
        navigation
      } = this.context;
      const routeViewEmitter = navigation.getRefToNavRouteEmitter();

      for (const eventKey in _NavigatorRouteViewEventEmitter.NavigatorRouteViewEvents) {
        const functionName = "handle-".concat(eventKey); // @ts-ignore

        routeViewEmitter.removeListener(eventKey, this[functionName]);
      }

      ;
    }

    render() {
      const props = this.props;
      return /*#__PURE__*/_react.default.createElement(WrappedComponent, _extends({}, props, {
        ref: this._handleChildRef
      }));
    }

  }, _defineProperty(_class, "contextType", _NavigationContext.NavigationContext), _temp;
}

;
//# sourceMappingURL=withRouteViewLifecycle.js.map