"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  RouteContentProps: true,
  NavigatorErrorCodes: true,
  NavigatorViewConstants: true,
  BackButtonDisplayMode: true,
  LargeTitleDisplayMode: true,
  NavigationBarVisibilityMode: true,
  StatusBarStyle: true,
  RouteConstantsObject: true,
  NavigatorConstantsObject: true,
  NativeRouteData: true,
  DynamicColor: true,
  Offset: true
};
Object.defineProperty(exports, "RouteContentProps", {
  enumerable: true,
  get: function () {
    return _NavigatorRouteView.RouteContentProps;
  }
});
Object.defineProperty(exports, "NavigatorErrorCodes", {
  enumerable: true,
  get: function () {
    return _NavigatorError.NavigatorErrorCodes;
  }
});
Object.defineProperty(exports, "NavigatorViewConstants", {
  enumerable: true,
  get: function () {
    return _RNINavigatorView.RNINavigatorViewConstants;
  }
});
Object.defineProperty(exports, "BackButtonDisplayMode", {
  enumerable: true,
  get: function () {
    return _RNINavigatorRouteView.BackButtonDisplayMode;
  }
});
Object.defineProperty(exports, "LargeTitleDisplayMode", {
  enumerable: true,
  get: function () {
    return _RNINavigatorRouteView.LargeTitleDisplayMode;
  }
});
Object.defineProperty(exports, "NavigationBarVisibilityMode", {
  enumerable: true,
  get: function () {
    return _RNINavigatorRouteView.NavigationBarVisibilityMode;
  }
});
Object.defineProperty(exports, "StatusBarStyle", {
  enumerable: true,
  get: function () {
    return _RNINavigatorRouteView.StatusBarStyle;
  }
});
Object.defineProperty(exports, "RouteConstantsObject", {
  enumerable: true,
  get: function () {
    return _RNINavigatorRouteViewModule.RouteConstantsObject;
  }
});
Object.defineProperty(exports, "NavigatorConstantsObject", {
  enumerable: true,
  get: function () {
    return _RNINavigatorViewModule.NavigatorConstantsObject;
  }
});
Object.defineProperty(exports, "NativeRouteData", {
  enumerable: true,
  get: function () {
    return _RNINavigatorViewModule.NativeRouteData;
  }
});
Object.defineProperty(exports, "DynamicColor", {
  enumerable: true,
  get: function () {
    return _MiscTypes.DynamicColor;
  }
});
Object.defineProperty(exports, "Offset", {
  enumerable: true,
  get: function () {
    return _MiscTypes.Offset;
  }
});

var _NavigatorView = require("./components/NavigatorView");

Object.keys(_NavigatorView).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _NavigatorView[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _NavigatorView[key];
    }
  });
});

var _NavigatorRouteView = require("./components/NavigatorRouteView");

var _RouteHeaderView = require("./components/RouteHeaderView");

Object.keys(_RouteHeaderView).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _RouteHeaderView[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _RouteHeaderView[key];
    }
  });
});

var _RouteViewPortal = require("./components/RouteViewPortal");

Object.keys(_RouteViewPortal).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _RouteViewPortal[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _RouteViewPortal[key];
    }
  });
});

var _RouteViewEvents = require("./components/RouteViewEvents");

Object.keys(_RouteViewEvents).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _RouteViewEvents[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _RouteViewEvents[key];
    }
  });
});

var _withRouteViewLifecycle = require("./hoc/withRouteViewLifecycle");

Object.keys(_withRouteViewLifecycle).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _withRouteViewLifecycle[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _withRouteViewLifecycle[key];
    }
  });
});

var _useNavRouteEvents = require("./hooks/useNavRouteEvents");

Object.keys(_useNavRouteEvents).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _useNavRouteEvents[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _useNavRouteEvents[key];
    }
  });
});

var _useNavigation = require("./hooks/useNavigation");

Object.keys(_useNavigation).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _useNavigation[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _useNavigation[key];
    }
  });
});

var _NavigationContext = require("./context/NavigationContext");

Object.keys(_NavigationContext).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _NavigationContext[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _NavigationContext[key];
    }
  });
});

var _NavigatorUIConstantsContext = require("./context/NavigatorUIConstantsContext");

Object.keys(_NavigatorUIConstantsContext).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _NavigatorUIConstantsContext[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _NavigatorUIConstantsContext[key];
    }
  });
});

var _NavBarAppearancePresets = require("./constants/NavBarAppearancePresets");

Object.keys(_NavBarAppearancePresets).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _NavBarAppearancePresets[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _NavBarAppearancePresets[key];
    }
  });
});

var _NavigatorError = require("./functions/NavigatorError");

var _RNINavigatorView = require("./native_components/RNINavigatorView");

var _RNINavigatorRouteView = require("./native_components/RNINavigatorRouteView");

var _RNINavigatorRouteViewModule = require("./native_modules/RNINavigatorRouteViewModule");

var _RNINavigatorViewModule = require("./native_modules/RNINavigatorViewModule");

var _RouteOptions = require("./types/RouteOptions");

Object.keys(_RouteOptions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _RouteOptions[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _RouteOptions[key];
    }
  });
});

var _NavigationObject = require("./types/NavigationObject");

Object.keys(_NavigationObject).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _NavigationObject[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _NavigationObject[key];
    }
  });
});

var _RouteSearchControllerConfig = require("./types/RouteSearchControllerConfig");

Object.keys(_RouteSearchControllerConfig).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _RouteSearchControllerConfig[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _RouteSearchControllerConfig[key];
    }
  });
});

var _NavBarAppearanceConfig = require("./types/NavBarAppearanceConfig");

Object.keys(_NavBarAppearanceConfig).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _NavBarAppearanceConfig[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _NavBarAppearanceConfig[key];
    }
  });
});

var _BarButtonItemAppearance = require("./types/BarButtonItemAppearance");

Object.keys(_BarButtonItemAppearance).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _BarButtonItemAppearance[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _BarButtonItemAppearance[key];
    }
  });
});

var _NavRouteItem = require("./types/NavRouteItem");

Object.keys(_NavRouteItem).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _NavRouteItem[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _NavRouteItem[key];
    }
  });
});

var _NavRouteConfigItem = require("./types/NavRouteConfigItem");

Object.keys(_NavRouteConfigItem).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _NavRouteConfigItem[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _NavRouteConfigItem[key];
    }
  });
});

var _RNINavigatorRouteViewEvents = require("./types/RNINavigatorRouteViewEvents");

Object.keys(_RNINavigatorRouteViewEvents).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _RNINavigatorRouteViewEvents[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _RNINavigatorRouteViewEvents[key];
    }
  });
});

var _RNINavigatorViewEvents = require("./types/RNINavigatorViewEvents");

Object.keys(_RNINavigatorViewEvents).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _RNINavigatorViewEvents[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _RNINavigatorViewEvents[key];
    }
  });
});

var _RouteHeaderConfig = require("./types/RouteHeaderConfig");

Object.keys(_RouteHeaderConfig).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _RouteHeaderConfig[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _RouteHeaderConfig[key];
    }
  });
});

var _ImageItemConfig = require("./types/ImageItemConfig");

Object.keys(_ImageItemConfig).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _ImageItemConfig[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _ImageItemConfig[key];
    }
  });
});

var _NavigationCommands = require("./types/NavigationCommands");

Object.keys(_NavigationCommands).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _NavigationCommands[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _NavigationCommands[key];
    }
  });
});

var _NavigatorViewEventEmitter = require("./types/NavigatorViewEventEmitter");

Object.keys(_NavigatorViewEventEmitter).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _NavigatorViewEventEmitter[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _NavigatorViewEventEmitter[key];
    }
  });
});

var _NavigatorRouteViewEventEmitter = require("./types/NavigatorRouteViewEventEmitter");

Object.keys(_NavigatorRouteViewEventEmitter).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _NavigatorRouteViewEventEmitter[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _NavigatorRouteViewEventEmitter[key];
    }
  });
});

var _NavTypes = require("./types/NavTypes");

Object.keys(_NavTypes).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _NavTypes[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _NavTypes[key];
    }
  });
});

var _MiscTypes = require("./types/MiscTypes");
//# sourceMappingURL=index.js.map