"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RNIWrapperView = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactNative = require("react-native");

var _RNIWrapperViewModule = require("../native_modules/RNIWrapperViewModule");

var Helpers = _interopRequireWildcard(require("../functions/Helpers"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const COMPONENT_NAME = 'RNIWrapperView';
const NativeComponent = (0, _reactNative.requireNativeComponent)(COMPONENT_NAME);

class RNIWrapperView extends _react.default.PureComponent {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "nativeRef", void 0);

    _defineProperty(this, "_handleNativeRef", ref => {
      this.nativeRef = ref;
    });

    _defineProperty(this, "notifyComponentWillUnmount", (isManuallyTriggered = true) => {
      _RNIWrapperViewModule.RNIWrapperViewModule.notifyComponentWillUnmount(Helpers.getNativeNodeHandle(this.nativeRef), {
        isManuallyTriggered
      });
    });
  }

  componentWillUnmount() {
    var _this$props$shouldNot;

    const shouldNotifyComponentWillUnmount = (_this$props$shouldNot = this.props.shouldNotifyComponentWillUnmount) !== null && _this$props$shouldNot !== void 0 ? _this$props$shouldNot : false;

    if (shouldNotifyComponentWillUnmount) {
      this.notifyComponentWillUnmount(false);
    }

    ;
  }

  render() {
    var _props$shouldNotifyCo;

    const props = this.props;
    return /*#__PURE__*/_react.default.createElement(NativeComponent, { ...props,
      ref: this._handleNativeRef,
      shouldNotifyComponentWillUnmount: (_props$shouldNotifyCo = props.shouldNotifyComponentWillUnmount) !== null && _props$shouldNotifyCo !== void 0 ? _props$shouldNotifyCo : false
    });
  }

}

exports.RNIWrapperView = RNIWrapperView;
;
//# sourceMappingURL=RNIWrapperView.js.map