function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import fastDeepEqual from "fast-deep-equal";
import { CompareUtilities } from './CompareUtilities';
import { compareColor } from './CompareMisc';

function comparePointOrPointPreset(oldItem, newItem) {
  if (typeof oldItem === 'string') {
    return oldItem === newItem;
  }

  ;
  return CompareUtilities.shallowCompareObject(oldItem, newItem);
}

;
export class CompareImageGradientConfig {
  static compare(oldItem, newItem) {
    return CompareUtilities.compareObject(CompareImageGradientConfig.propertyMap, oldItem, newItem);
  }

}

_defineProperty(CompareImageGradientConfig, "propertyMap", {
  type: {
    mode: 'shallow'
  },
  width: {
    mode: 'shallow'
  },
  height: {
    mode: 'shallow'
  },
  borderRadius: {
    mode: 'shallow'
  },
  colors: {
    mode: 'shallowArray'
  },
  locations: {
    mode: 'shallowArray'
  },
  startPoint: {
    mode: 'custom',
    customCompare: comparePointOrPointPreset
  },
  endPoint: {
    mode: 'custom',
    customCompare: comparePointOrPointPreset
  }
});

;
export class CompareImageRectConfig {
  static compare(oldItem, newItem) {
    return CompareUtilities.compareObject(this.propertyMap, oldItem, newItem);
  }

}

_defineProperty(CompareImageRectConfig, "propertyMap", {
  width: {
    mode: 'shallow'
  },
  height: {
    mode: 'shallow'
  },
  fillColor: {
    mode: 'shallow'
  },
  borderRadius: {
    mode: 'shallow'
  }
});

;
export class CompareImageSystemConfig {
  static compare(oldItem, newItem) {
    return CompareUtilities.compareObject(this.propertyMap, oldItem, newItem);
  }

}

_defineProperty(CompareImageSystemConfig, "propertyMap", {
  systemName: {
    mode: 'shallow'
  },
  pointSize: {
    mode: 'shallow'
  },
  weight: {
    mode: 'shallow'
  },
  scale: {
    mode: 'shallow'
  },
  hierarchicalColor: {
    mode: 'shallow'
  },
  paletteColors: {
    mode: 'shallowArray'
  }
});

;
export class CompareUIImageConfig {
  static compare(oldItem, newItem) {
    return CompareUtilities.compareObject(CompareUIImageConfig.propertyMap, oldItem, newItem, true);
    ;
  }

}

_defineProperty(CompareUIImageConfig, "propertyMap", {
  renderingMode: {
    mode: 'shallow'
  },
  tint: {
    mode: 'custom',
    customCompare: compareColor
  }
});

;
export class CompareImageConfig {
  static compare(oldItem, newItem) {
    if (oldItem.type !== newItem.type) return false;

    switch (oldItem.type) {
      case 'IMAGE_REQUIRE':
        return CompareUIImageConfig.compare(oldItem.imageOptions, newItem.imageOptions) || fastDeepEqual(oldItem.imageValue, newItem.imageOptions);

      case 'IMAGE_ASSET':
        return CompareUIImageConfig.compare(oldItem.imageOptions, newItem.imageOptions) || oldItem.imageValue === newItem.imageValue;

      case 'IMAGE_SYSTEM':
        return CompareUIImageConfig.compare(oldItem.imageOptions, newItem.imageOptions) || CompareImageSystemConfig.compare(oldItem.imageValue, newItem.imageValue);

      case 'IMAGE_RECT':
        return CompareImageRectConfig.compare(oldItem.imageValue, newItem.imageValue);

      case 'IMAGE_GRADIENT':
        return CompareImageGradientConfig.compare(oldItem.imageValue, newItem.imageValue);

      default:
        return fastDeepEqual(oldItem, newItem);
    }

    ;
  }

}
;
//# sourceMappingURL=CompareImageConfig.js.map