function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// @refresh reset
import React from 'react';
import { NavigatorRouteView } from '../components/NavigatorRouteView';

/**
 * This component is a wrapper for `NavigatorRouteView`.
 * * Responsible for handling the render props (i.e. so that the anon/arrow functions
 * aren't re-created on each re-render).
 * * Used in `NavigatorView._renderRoutes`.
 */
export class NavigatorRouteViewWrapper extends React.Component {
  constructor(..._args) {
    super(..._args);

    _defineProperty(this, "_handleRef", ref => {
      const props = this.props;
      props.innerRef(ref, props.route);
    });

    _defineProperty(this, "_handleRenderRouteContent", () => {
      const props = this.props;
      const routeConfig = this.props.routeConfig;
      return routeConfig.renderRoute(props.route);
    });

    _defineProperty(this, "_handleRenderNavBarLeftItem", args => {
      var _routeConfig$renderNa, _routeConfig$renderNa2, _props$renderDefaultN;

      const props = this.props;
      const routeConfig = this.props.routeConfig;
      return (_routeConfig$renderNa = (_routeConfig$renderNa2 = routeConfig.renderNavBarLeftItem) === null || _routeConfig$renderNa2 === void 0 ? void 0 : _routeConfig$renderNa2.call(routeConfig, args)) !== null && _routeConfig$renderNa !== void 0 ? _routeConfig$renderNa : (_props$renderDefaultN = props.renderDefaultNavBarLeftItem) === null || _props$renderDefaultN === void 0 ? void 0 : _props$renderDefaultN.call(props, args);
    });

    _defineProperty(this, "_handleRenderNavBarRightItem", args => {
      var _routeConfig$renderNa3, _routeConfig$renderNa4, _props$renderDefaultN2;

      const props = this.props;
      const routeConfig = this.props.routeConfig;
      return (_routeConfig$renderNa3 = (_routeConfig$renderNa4 = routeConfig.renderNavBarRightItem) === null || _routeConfig$renderNa4 === void 0 ? void 0 : _routeConfig$renderNa4.call(routeConfig, args)) !== null && _routeConfig$renderNa3 !== void 0 ? _routeConfig$renderNa3 : (_props$renderDefaultN2 = props.renderDefaultNavBarRightItem) === null || _props$renderDefaultN2 === void 0 ? void 0 : _props$renderDefaultN2.call(props, args);
    });

    _defineProperty(this, "_handleRenderNavBarTitleItem", args => {
      var _routeConfig$renderNa5, _routeConfig$renderNa6, _props$renderDefaultN3;

      const props = this.props;
      const routeConfig = this.props.routeConfig;
      return (_routeConfig$renderNa5 = (_routeConfig$renderNa6 = routeConfig.renderNavBarTitleItem) === null || _routeConfig$renderNa6 === void 0 ? void 0 : _routeConfig$renderNa6.call(routeConfig, args)) !== null && _routeConfig$renderNa5 !== void 0 ? _routeConfig$renderNa5 : (_props$renderDefaultN3 = props.renderDefaultNavBarTitleItem) === null || _props$renderDefaultN3 === void 0 ? void 0 : _props$renderDefaultN3.call(props, args);
    });
  }

  render() {
    const props = this.props;
    return /*#__PURE__*/React.createElement(NavigatorRouteView, {
      ref: this._handleRef,
      navigatorID: props.navigatorID,
      routeID: props.routeID,
      routeKey: props.routeKey,
      routeIndex: props.routeIndex,
      routeProps: props.routeProps,
      isInFocus: props.currentActiveRouteIndex === props.routeIndex,
      routeOptionsDefault: props.routeOptionsDefault,
      transitionConfigPushOverride: props.transitionConfigPushOverride,
      transitionConfigPopOverride: props.transitionConfigPopOverride,
      getRefToNavigator: props.getRefToNavigator,
      renderRouteContent: this._handleRenderRouteContent,
      renderNavBarLeftItem: this._handleRenderNavBarLeftItem,
      renderNavBarRightItem: this._handleRenderNavBarRightItem,
      renderNavBarTitleItem: this._handleRenderNavBarTitleItem
    });
  }

}
;
//# sourceMappingURL=NavigatorRouteViewWrapper.js.map