import type { NeverUndefined, Nullish } from "../types/UtilityTypes";
export declare type ComparisonConfig<T> = {
    [K in keyof Required<T>]: {
        mode: "shallow" | "shallowObject" | "shallowArray" | "deep" | "ignore";
    } | {
        mode: "custom";
        customCompare: <V extends NeverUndefined<T[K]>>(itemA: V, itemB: V) => boolean;
    };
};
export declare class CompareUtilities {
    static shallowCompareArray<T extends Array<any>>(itemA: T, itemB: T): boolean;
    static shallowCompareObject<T extends object>(itemA: T, itemB: T): boolean;
    static unwrapAndShallowCompareObject<T extends object>(itemA: Nullish<T>, itemB: Nullish<T>): boolean;
    static compareObject<T extends {
        [k: string]: any;
    }>(propertyMap: ComparisonConfig<T>, oldItem: T, newItem: T, 
    /** Skip checking properties with no matching config */
    skipIfNoConfig?: boolean): boolean;
}
