import type React from 'react';
import type { Nullish } from '../types/UtilityTypes';
/** wrapper func for setState that returns a promise */
export declare function setStateAsync<T>(that: React.Component, newState: T | ((prevState: T) => T)): Promise<void>;
/** wrapper for timeout that returns a promise */
export declare function timeout(ms: Number): Promise<void>;
/** Wraps a promise that will reject if not not resolved in <ms> milliseconds */
export declare function promiseWithTimeout<T>(ms: Number, promise: Promise<T>): Promise<T>;
export declare function isClassComponent(component: unknown): boolean;
export declare function lastElement<T>(array: Array<T>): T | undefined;
export declare function arrayInsert<T>(array: Array<T>, index: number, newItem: T): T[];
export declare function addOptional<T extends object, U extends object>(a: T, b: U | null): T & Partial<U>;
export declare function shallowMergeObjects<T extends object>(a: Nullish<T>, b: Nullish<T>): T | null;
export declare function getNativeNodeHandle(nativeRef: React.Component): number;
