export declare enum NavigatorErrorCodes {
    activeRoutesDeSync = "activeRoutesDeSync",
    libraryError = "libraryError",
    invalidRouteID = "invalidRouteID",
    invalidRouteKey = "invalidRouteKey",
    invalidRouteIndex = "invalidRouteIndex",
    invalidReactTag = "invalidReactTag",
    invalidArguments = "invalidArguments",
    routeOutOfBounds = "routeOutOfBounds",
    invalidProps = "invalidProps"
}
export declare type NavigatorErrorObject = {
    code: NavigatorErrorCodes;
    domain?: string;
    message?: string;
    debug?: string;
};
export declare class NavigatorError extends Error {
    name: NavigatorErrorCodes | string;
    message: string;
    constructor(error: unknown);
    static isErrorObject(obj: unknown): obj is Error;
    static isNavigatorErrorObject(obj: object): obj is NavigatorErrorObject;
    static parseErrorObject(error: unknown): NavigatorErrorObject | null;
    static createErrorString(error: Partial<NavigatorErrorObject>): string;
}
