/**
 * Very naive impl. of a async operation queue.
 * * For every call of `schedule`, `dequeue` must be called at the end
 *   to start the next operation in the queue.
 * * As such, the length of the queue is not enough by itself to diff. if
 *   the queue is busy, so as workaround there's a `_isBusy` property.
 * * This can be fixed by changing `schedule` so that it accepts a closure,
 *   and then automatically calling the next item in the queue.
 * * For now though, this impl. should suffice... 😔
 */
export declare class SimpleQueue {
    private _isBusy;
    private queue;
    private queueKey;
    schedule: () => Readonly<{
        queueKey: number;
        promise: Promise<void>;
        cancel: Function;
    }>;
    cancel(queueKey: number): void;
    dequeue(): void;
    clear(): void;
    isBusy(): boolean;
}
