import { ViewProps } from 'react-native';
import type { OnCustomCommandFromNativeEvent, OnNativeCommandRequestEvent, OnNavRouteDidShowEvent, OnNavRoutePopEvent, OnNavRouteViewAddedEvent, OnNavRouteWillShowEvent, OnSetNativeRoutesEvent, OnUIConstantsDidChangeEvent } from '../types/RNINavigatorViewEvents';
import type { NavBarAppearanceCombinedConfig } from '../types/NavBarAppearanceConfig';
import type { Nullish } from '../types/UtilityTypes';
export declare type NativeRouteMap = {
    [key: string]: {
        routeKey: string;
        routeIndex: number;
        routeProps?: object;
    };
};
/** `RNINavigatorView` native comp. props */
export declare type RNINavigatorViewProps = ViewProps & {
    navigatorID: number;
    nativeRoutes: NativeRouteMap;
    initialRouteKeys: Array<string>;
    isInteractivePopGestureEnabled: boolean;
    shouldSwizzleRootViewController: boolean;
    disableTransparentNavBarScrollEdgeAppearance: boolean;
    navBarPrefersLargeTitles: boolean;
    isNavBarTranslucent: boolean;
    navBarAppearance: Nullish<NavBarAppearanceCombinedConfig>;
    onNavRouteViewAdded?: OnNavRouteViewAddedEvent;
    onSetNativeRoutes?: OnSetNativeRoutesEvent;
    onNavRouteWillPop?: OnNavRoutePopEvent;
    onNavRouteDidPop?: OnNavRoutePopEvent;
    onNavRouteWillShow?: OnNavRouteWillShowEvent;
    onNavRouteDidShow?: OnNavRouteDidShowEvent;
    onNativeCommandRequest?: OnNativeCommandRequestEvent;
    onCustomCommandFromNative?: OnCustomCommandFromNativeEvent;
    onUIConstantsDidChange?: OnUIConstantsDidChangeEvent;
};
export declare type RNINavigatorViewConstantsObject = {
    navigationBarHeight: number;
};
export declare const RNINavigatorView: import("react-native").HostComponent<RNINavigatorViewProps>;
export declare const RNINavigatorViewConstants: RNINavigatorViewConstantsObject;
