import type { ReactElement } from "react";
import type { RouteContentProps } from "../components/NavigatorRouteView";
import type { NavRouteItem } from "./NavRouteItem";
import type { RenderNavItem } from "./NavTypes";
import type { RouteOptions } from "./RouteOptions";
declare type NavRouteConfigItemBase = {
    initialRouteProps?: object;
};
/** Native route config */
export declare type NavRouteConfigItemNative = NavRouteConfigItemBase & {
    isNativeRoute: true;
};
/** JS/React route config */
export declare type NavRouteConfigItemJS = NavRouteConfigItemBase & {
    isNativeRoute?: false | undefined;
    routeOptionsDefault?: RouteOptions;
    renderRoute: (routeItem: Readonly<NavRouteItem>) => ReactElement<RouteContentProps>;
    renderNavBarLeftItem?: RenderNavItem;
    renderNavBarRightItem?: RenderNavItem;
    renderNavBarTitleItem?: RenderNavItem;
};
export declare type NavRouteConfigItem = NavRouteConfigItemNative | NavRouteConfigItemJS;
export {};
