import type { TSEventEmitter } from '@dominicstop/ts-event-emitter';
import type { OnPressNavBarItemEventObject, OnRouteFocusEventObject, OnRouteBlurEventObject, OnRoutePopEventObject, OnRoutePushEventObject, OnSearchBarCancelButtonClickedEventObject, OnSearchBarSearchButtonClickedEventObject, OnUpdateSearchResultsEventObject } from "./RNINavigatorRouteViewEvents";
import type { KeyMapType } from "./UtilityTypes";
export declare enum NavigatorRouteViewEvents {
    onRouteWillPush = "onRouteWillPush",
    onRouteDidPush = "onRouteDidPush",
    onRouteWillPop = "onRouteWillPop",
    onRouteDidPop = "onRouteDidPop",
    onRouteWillFocus = "onRouteWillFocus",
    onRouteDidFocus = "onRouteDidFocus",
    onRouteWillBlur = "onRouteWillBlur",
    onRouteDidBlur = "onRouteDidBlur",
    onPressNavBarLeftItem = "onPressNavBarLeftItem",
    onPressNavBarRightItem = "onPressNavBarRightItem",
    onUpdateSearchResults = "onUpdateSearchResults",
    onSearchBarCancelButtonClicked = "onSearchBarCancelButtonClicked",
    onSearchBarSearchButtonClicked = "onSearchBarSearchButtonClicked"
}
export declare type NavigatorRouteViewEventMap = KeyMapType<NavigatorRouteViewEvents, {
    onRouteWillPush: OnRoutePushEventObject;
    onRouteDidPush: OnRoutePushEventObject;
    onRouteWillPop: OnRoutePopEventObject;
    onRouteDidPop: OnRoutePopEventObject;
    onRouteWillFocus: OnRouteFocusEventObject;
    onRouteDidFocus: OnRouteFocusEventObject;
    onRouteWillBlur: OnRouteBlurEventObject;
    onRouteDidBlur: OnRouteBlurEventObject;
    onPressNavBarLeftItem: OnPressNavBarItemEventObject;
    onPressNavBarRightItem: OnPressNavBarItemEventObject;
    onUpdateSearchResults: OnUpdateSearchResultsEventObject;
    onSearchBarCancelButtonClicked: OnSearchBarCancelButtonClickedEventObject;
    onSearchBarSearchButtonClicked: OnSearchBarSearchButtonClickedEventObject;
}>;
export declare type NavigatorRouteViewEventEmitter = TSEventEmitter<NavigatorRouteViewEvents, NavigatorRouteViewEventMap>;
