import type { TSEventEmitter } from '@dominicstop/ts-event-emitter';
import type { OnNavRouteDidShowEventObject, OnNavRoutePopEventObject, OnNavRouteViewAddedEventObject, OnSetNativeRoutesEventObject } from "./RNINavigatorViewEvents";
import type { KeyMapType } from "./UtilityTypes";
export declare enum NavigatorViewEvents {
    onNavRouteViewAdded = "onNavRouteViewAdded",
    onSetNativeRoutes = "onSetNativeRoutes",
    onNavRouteDidPop = "onNavRouteDidPop",
    onNavRouteDidShow = "onNavRouteDidShow"
}
export declare type NavigatorViewEventMap = KeyMapType<NavigatorViewEvents, {
    onNavRouteViewAdded: OnNavRouteViewAddedEventObject;
    onSetNativeRoutes: OnSetNativeRoutesEventObject;
    onNavRouteDidPop: OnNavRoutePopEventObject;
    onNavRouteDidShow: OnNavRouteDidShowEventObject;
}>;
export declare type NavigatorViewEventEmitter = TSEventEmitter<NavigatorViewEvents, NavigatorViewEventMap>;
