import type { NativeActiveRoutes } from 'src/native_modules/RNINavigatorViewModule';
import type { EdgeInsets, Rect } from './MiscTypes';
declare type EventBaseEventObject = {
    target: number;
    navigatorID: number;
};
export declare type OnNavRouteViewAddedEventObject = {
    nativeEvent: EventBaseEventObject & {
        routeID: number;
        routeKey: string;
        routeIndex: number;
        isNativeRoute: boolean;
    };
};
export declare type OnNavRoutePopEventObject = {
    nativeEvent: EventBaseEventObject & {
        routeID: number;
        routeKey: string;
        routeIndex: number;
        isUserInitiated: boolean;
    };
};
export declare type OnNavRouteWillShowEventObject = {
    nativeEvent: EventBaseEventObject & NativeActiveRoutes;
};
export declare type OnNavRouteDidShowEventObject = {
    nativeEvent: EventBaseEventObject & NativeActiveRoutes;
};
export declare type OnSetNativeRoutesEventObject = {
    nativeEvent: EventBaseEventObject;
};
export declare type OnNativeCommandRequestEventObject = {
    nativeEvent: EventBaseEventObject & {
        commandData: {
            commandKey: 'pushViewController';
            routeID: number;
            routeKey: string;
            isAnimated: boolean;
        } | {
            commandKey: 'push';
            routeKey: string;
            routeProps?: object;
            isAnimated: boolean;
        } | {
            commandKey: 'pop';
            isAnimated: boolean;
        };
    };
};
export declare type OnCustomCommandFromNativeEventObject = {
    nativeEvent: EventBaseEventObject & {
        commandKey: string;
        commandData: object;
    };
};
export declare type OnUIConstantsDidChangeEventObject = {
    nativeEvent: EventBaseEventObject & {
        statusBarHeight: number;
        safeAreaInsets: EdgeInsets;
        navigatorSize: Rect;
    };
};
export declare type OnNavRouteViewAddedEvent = (event: Readonly<OnNavRouteViewAddedEventObject>) => void;
export declare type OnNavRoutePopEvent = (event: Readonly<OnNavRoutePopEventObject>) => void;
export declare type OnSetNativeRoutesEvent = (event: Readonly<OnSetNativeRoutesEventObject>) => void;
export declare type OnNativeCommandRequestEvent = (event: Readonly<OnNativeCommandRequestEventObject>) => void;
export declare type OnCustomCommandFromNativeEvent = (event: Readonly<OnCustomCommandFromNativeEventObject>) => void;
export declare type OnNavRouteWillShowEvent = (event: Readonly<OnNavRouteWillShowEventObject>) => void;
export declare type OnNavRouteDidShowEvent = (event: Readonly<OnNavRouteDidShowEventObject>) => void;
export declare type OnUIConstantsDidChangeEvent = (event: Readonly<OnUIConstantsDidChangeEventObject>) => void;
export {};
