import React from 'react';
import { ViewStyle } from 'react-native';
import type { EdgeInsets } from '../types/MiscTypes';
import type { NavigatorRouteViewProps } from '../components/NavigatorRouteView';
declare type NavigatorRouteContentWrapperProps = Pick<NavigatorRouteViewProps, 'isInFocus'> & {
    hasRouteHeader: boolean;
    automaticallyAddHorizontalSafeAreaInsets: boolean | undefined;
    routePropsUpdateIndex: number;
    safeAreaInsets: EdgeInsets | undefined;
    routeContainerStyle?: ViewStyle;
};
/**
 * Wraps the react element returned from `props.renderRouteContent()`
 * render prop in `NavigatorRouteView._renderRouteContents`.
 * * The purpose of this component is to stop unnecessary re-renders from
 *   propagating down to the "route content".
 */
export declare class NavigatorRouteContentWrapper extends React.Component<NavigatorRouteContentWrapperProps> {
    shouldComponentUpdate(nextProps: NavigatorRouteContentWrapperProps): boolean;
    render(): JSX.Element;
}
export {};
