import React from 'react';
import type { NavRouteStackItem } from '../types/NavRouteItem';
import type { RenderNavItem, RenderRouteContent } from '../types/NavTypes';
import type { NavRouteConfigItemJS } from '../types/NavRouteConfigItem';
import { NavigatorRouteView, NavigatorRouteViewProps } from '../components/NavigatorRouteView';
declare type NavigatorRouteViewWrapperProps = Pick<NavigatorRouteViewProps, 'navigatorID' | 'routeID' | 'routeKey' | 'routeIndex' | 'routeProps' | 'routeOptionsDefault' | 'transitionConfigPushOverride' | 'transitionConfigPopOverride' | 'getRefToNavigator'> & {
    innerRef: (ref: NavigatorRouteView | null, route: NavRouteStackItem) => void;
    route: NavRouteStackItem;
    routeConfig: NavRouteConfigItemJS;
    currentActiveRouteIndex: number;
    renderDefaultNavBarLeftItem: RenderNavItem | undefined;
    renderDefaultNavBarRightItem: RenderNavItem | undefined;
    renderDefaultNavBarTitleItem: RenderNavItem | undefined;
};
/**
 * This component is a wrapper for `NavigatorRouteView`.
 * * Responsible for handling the render props (i.e. so that the anon/arrow functions
 * aren't re-created on each re-render).
 * * Used in `NavigatorView._renderRoutes`.
 */
export declare class NavigatorRouteViewWrapper extends React.Component<NavigatorRouteViewWrapperProps> {
    _handleRef: (ref: NavigatorRouteView | null) => void;
    _handleRenderRouteContent: RenderRouteContent;
    _handleRenderNavBarLeftItem: RenderNavItem;
    _handleRenderNavBarRightItem: RenderNavItem;
    _handleRenderNavBarTitleItem: RenderNavItem;
    render(): JSX.Element;
}
export {};
